unit utuEmprestimoOQL;

interface

uses acuOQL, acuFramework;

type

  IObterClientes = interface(IOQLQuery)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  utEmprestimoOQL = class
    class function ObterClientes(piSessao: acPersistenceSession): IObterClientes;
  end;

implementation

type

  TObterClientes = class(acOQLQuery, IObterClientes)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

{ TObterClientes }

function TObterClientes.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterClientes.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ utOQLs }

class function utEmprestimoOQL.ObterClientes(piSessao: acPersistenceSession): IObterClientes;
begin
  result := TObterClientes.Create(pisessao,
'SELECT ngCliente' + #13#10 +
'FROM ngCliente' + #13#10 +
'WHERE (ngCliente.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL)' + #13#10 +
'	AND (ngCliente.CPF = ?cpf:acString OR ?cpf:acString IS NULL)');
end;

end.
